'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Icons = require('./Icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ToggleButton = function ToggleButton(_ref) {
  var onToggle = _ref.onToggle,
      className = _ref.className,
      toggleIcon = _ref.toggleIcon,
      size = _ref.size,
      expanded = _ref.expanded;

  var toggleIconProps = {
    className: className,
    size: size,
    expanded: expanded,
    onClick: function onClick(event) {
      // don't lose focus
      event.preventDefault();
      onToggle();
    }
  };

  var toggleButtonEl = void 0;
  if (toggleIcon) {
    var params = {
      onToggle: onToggle,
      expanded: expanded,
      domProps: toggleIconProps
    };

    toggleButtonEl = typeof toggleIcon === 'function' ? toggleIcon(params) : toggleIcon;
  }

  if (toggleButtonEl === true || toggleButtonEl == undefined) {
    toggleButtonEl = _react2.default.createElement(_Icons.ToggleIcon, toggleIconProps);
  }

  return toggleButtonEl;
}; /**
    * Copyright (c) 2015-present, Zippy Technologies
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */

ToggleButton.defaultProps = {
  size: 10
};

ToggleButton.propTypes = {
  expanded: _propTypes2.default.bool,
  size: _propTypes2.default.number
};

exports.default = ToggleButton;