'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _region = require('@zippytech/region');

var _region2 = _interopRequireDefault(_region);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getRelativeRegion(domNode) {
  var parentRegion = _region2.default.from(domNode.parentNode);
  var region = _region2.default.from(domNode);

  region.shift({
    left: -parentRegion.left,
    top: -parentRegion.top
  });

  return region;
} /**
   * Copyright (c) 2015-present, Zippy Technologies
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

exports.default = getRelativeRegion;