'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.simulateKeyboardEvent = exports.simulateMouseEvent = exports.render = undefined;

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var render = function render(cmp) {
  var targetNode = document.createElement('div');

  targetNode.style.height = '600px';
  targetNode.style.width = '1000px';
  document.body.appendChild(targetNode);

  var instance = _reactDom2.default.render(cmp, targetNode);

  instance.rerender = function (cmp) {
    return _reactDom2.default.render(cmp, targetNode);
  };

  instance.unmount = function () {
    _reactDom2.default.unmountComponentAtNode(targetNode);
    document.body.removeChild(targetNode);
  };

  return instance;
}; /**
    * Copyright (c) 2015-present, Zippy Technologies
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */

exports.default = render;


function simulateMouseEvent(eventType, target) {
  var evt = new MouseEvent(eventType, {
    bubbles: true,
    cancelable: true,
    view: global
  });
  target.dispatchEvent(evt);
}

function simulateKeyboardEvent(eventType, target, key) {
  var evt = new KeyboardEvent(eventType, {
    bubbles: true,
    cancelable: true,
    view: window,
    key: key
  });
  target.dispatchEvent(evt);
}

exports.render = render;
exports.simulateMouseEvent = simulateMouseEvent;
exports.simulateKeyboardEvent = simulateKeyboardEvent;